/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2017 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/*set debug_level=1.*/

/* run */ define test() = {
  exists A : { A=0 and 
    len(4) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.

/* run */ define test1a() = {
  exists A : { 
    {A=0 and 
    len(1) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
  }
}.

/* run */ define test1b() = {
  exists A : { 
    {A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
  }
}.

/* run */ define test1() = {
  exists A : { 
    {A=0 and  
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) };
    {len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
    
  }
}.

/* run */ define test2() = {
  exists A,B : { 
    {A=0 and B=2 and empty};skip;{B=prev(A)+3 and output(B) and output(prev(A)) and output(prev(B))
  and empty}
    
  }
}.

/* run */ define test3() = {
  exists A : { 
    {A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) };
    {len(3) and A gets prev(A)+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) }
    
  }
}.



/* run */ define test11() = {
  exists A,B : { 
    List(A,3) and stable(struct(A)) and 
     List(B,4) and stable(struct(B)) and
    always (output(prev(A)) and output(B) and output(A)) and
    { 
     {A=[0,1,2] and B=[2] and empty }
     ;skip;{B=prev(A)+[3] and empty and A=[1,2]}
    }
  }
}.

/* run */ define test11a() = {
  exists A,B : { 
    {List(A,3) and stable(struct(A)) and 
     List(B,4) and stable(struct(B))} and
    { 
     {A=[0,1,2] and B=[2] and output(A) and output(B) and skip and
      B[0]:=3 and B[1]:=4 and next(|B|=2) and |B|=1};
     {output(B) and output(prev(B)) and empty}
    }
  }
}.


/* this test should fail */
/* run */ define test13() = {
  exists A : { prev(A)=4 and A=0 and 
    len(2) and A gets A+1 and 
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.

/* run */ define test14() = {
  exists A : { A=0 and 
    len(2) and A gets A+1 and next(prev(A)=0) and
    always( output(prev(A)) and output(A) and 
            (more implies output(next(A)) and output(next(prev(A)))
            and output(prev(next(A)))) ) 
    
  }
}.
